/*
 * Copyright © 2018 Apple Inc. and the ServiceTalk project authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.servicetalk.concurrent.reactivestreams.tck;

import io.servicetalk.concurrent.api.Completable;
import io.servicetalk.concurrent.api.Single;

import org.testng.annotations.Test;

@Test
public class SingleFlatMapCompletableTckTest extends AbstractSingleOperatorTckTest<Void> {

    @Override
    protected Single<Void> composeSingle(Single<Integer> single) {
        return single.flatMapCompletable(v -> Completable.completed()).toSingle();
    }

    @Override
    public long maxElementsFromPublisher() {
        return 0;
    }
}
